Index: tools/udp_pes_scheduler.h
===================================================================
RCS file: /cvsroot/xineliboutput/vdr-xineliboutput/tools/udp_pes_scheduler.h,v
retrieving revision 1.11
diff -U3 -r1.11 udp_pes_scheduler.h
--- tools/udp_pes_scheduler.h	24 Jan 2007 01:04:09 -0000	1.11
+++ tools/udp_pes_scheduler.h	29 Mar 2007 12:41:31 -0000
@@ -68,6 +68,7 @@
     int m_QueueNextSeq;      /* next outgoing */
     int m_QueuePending;      /* outgoing queue size */
     cUdpBackLog *m_BackLog;  /* queue for incoming data (not yet send) and retransmissions */
+    cMutex m_BackLogDeleteMutex;
 
     // Data for scheduling algorithm
     cTimePts  MasterClock;   /* Current MPEG PTS (synchronized to current stream) */
Index: tools/udp_pes_scheduler.c
===================================================================
RCS file: /cvsroot/xineliboutput/vdr-xineliboutput/tools/udp_pes_scheduler.c,v
retrieving revision 1.29
diff -U3 -r1.29 udp_pes_scheduler.c
--- tools/udp_pes_scheduler.c	14 Mar 2007 11:47:44 -0000	1.29
+++ tools/udp_pes_scheduler.c	29 Mar 2007 12:41:31 -0000
@@ -268,8 +300,11 @@
     // Flush all buffers
     m_QueueNextSeq = 0;
     m_QueuePending = 0;
+
+    m_BackLogDeleteMutex.Lock();
     delete m_BackLog; 
     m_BackLog = new cUdpBackLog;
+    m_BackLogDeleteMutex.Unlock();
 
     m_Frames = 0;
     m_Octets = 0;
@@ -674,7 +709,7 @@
     m_QueuePending--;
 
     m_Cond.Broadcast();
- 
+    m_BackLogDeleteMutex.Lock(); /* ensure frame will not be deleted from queue */
     m_Lock.Unlock();
 
     // Schedule frame
@@ -748,7 +784,9 @@
       }
     }
 
+    m_BackLogDeleteMutex.Unlock(); /* release queue */
     m_Lock.Lock();
+
     m_Frames ++;
     m_Octets += PayloadSize;
     if(m_fd_rtcp.open() && (m_Frames & 0xff) == 1) { // every 256th frame
